! function() {
    if((window&&!window["tt"]) || !tt) {
        return;
    }
    let PEQ = {
        registerHandler: function(callback) {
            if (this.data) {
                callback(this.data);
            } else {
                this.config.parse = callback;
            }
        },
        init: function(vconfig) {
            console.log("[EQSDK]!!!eq init start");
            this.config = vconfig;
            this.config.api_url = "https://oppomini.eqmobi.com/toutiao/" + this.config.EQAPPKEY + "/" + this.config.EQVERSION + "/api";
            this.config.login_url = "https://oppomini.eqmobi.com/toutiao/" + this.config.EQAPPKEY + "/" + this.config.EQVERSION + "/login";
            this.config.enable = false;
            this.config.savedir = "";
            this.savefuc = tt.setStorage;
            this.loadfuc = tt.getStorage;
            this.netpost = tt.request;
            this.showuserbuttonfunc = tt.createUserInfoButton;
            try {
                if(tt.onNavigateToMiniProgram) {
                    console.log("[EQSDK]!!!eq try catch");
                    tt.onNavigateToMiniProgram((res)=> {
                        switch(res.errCode) {
                        case 0: {
                            this.sendevent("跳转成功回调", res);
                        }
                            break;
                        case 1: {
                            this.sendevent("跳转失败", res);
                        }
                            break;
                        case 2: {
                            this.sendevent("跳转取消", res);
                        }
                            break;
                        }
                    });
                }
            } catch (E) {

            }
            //this.config.data = {};
            this.config.launcheroption = tt.getLaunchOptionsSync();
            this.config.sysinfo = tt.getSystemInfoSync();
            var mylogin = () => {
                this.d("need login");
                this.login({
                    skipuserinfo: true,
                    success: (p) => {
                        //tt.offTouchEnd(mylogin);
                        if(this.config.onLoginned) {
                            this.config.onLoginned(this.config.userinfo);
                        }
                    },
                    fail:(p)=> {
                        //tt.offTouchEnd(mylogin);
                    }
                });
            };
            try {
                let res = tt.getStorageSync( 'eq4096user.json');
                if(res) {
                    this.d('local read', res);
                    this.config.userinfo = res;
                    if(res.openId && res.openId != '') {
                        this.d("skip login");
                        if(res.userinfo && typeof(res.userinfo) === 'string') {
                            this.config.userinfo.userinfo = JSON.parse(res.userinfo);
                        }
                        if(this.config.onLoginned) {
                            this.config.onLoginned(this.config.userinfo);
                        }
                    } else {
                        mylogin();
                        //tt.onTouchEnd(mylogin);
                    }
                } else {
                    mylogin();
                    //tt.onTouchEnd(mylogin);
                }
            } catch(file_error) {
                //tt.onTouchEnd(mylogin);
                this.d("check login error", file_error);
                mylogin();
            }
            tt.eqSendEvent = (key, v,callback=null) => {
                this.sendevent(key, v, callback);
            };
            this.syncdata();
            tt.eqLogin = (c) => {
                this.eqlogin(c);
            };
            tt.eqRegisterHandler = (fn) => {
                this.registerHandler(fn);
            };
            tt.eqGetConfig = () => {
                return this.config;
            };
            tt.eqTouch = (d) => {
                this.touch(d);
            };
            if(tt["onAppShow"]) {
                tt.onAppShow((res) => {
                    this.onShow(res);
                });
            }
            if(tt["onAppHide"]) {
                tt.onAppHide((res) => {
                    this.onHide(res);
                });
            }
            if(tt["onShow"]) {
                tt.onShow((res) => {
                    this.onShow(res);
                });
            }
            if(tt["onHide"]) {
                tt.onHide((res) => {
                    this.onHide(res);
                });
            }
            tt.onError((msg, stack) => {
                this.d("onError", msg);
                this.onError(msg, stack);
            });
        },
        sendevent: function(key, obj, callback=null) {
            //this.config.event = e;
            let vconfig = this.config;
            //delete vconfig.data;
            if(vconfig.skip_event) {
                if(vconfig.skip_event.indexOf(key)>=0) {
                    return;
                }
            }
            this.netpost({
                url: this.config.api_url,
                method: "POST",
                dataType: "json",
                data: {
                    "event": {
                        "key": key,
                        "obj": obj
                    },
                    config: vconfig
                },
                success: (res1) => {
                    let res = res1.data;
                    res.data&&res.data.eqop && this[res.data.eqop](res.data[res.data.eqop]);
                    res.data&&res.data.op && tt[res.data.op](res.data[res.data.op]);
                    if(callback) {callback(res);}
                    console.log("[EQSDK]!!!eq sendevent success");
                },
                fail: (err) => {
                    this.d("syncdata err=", err);
                }
            });
        },
        codelogin: function(callback) {
            this.d(callback);
            this.config.puserinfo = callback.puserinfo;
            this.d(this.config);
            this.netpost({
                method: "POST",
                dataType: "json",
                url: this.config.login_url,
                data: this.config,
                success: (d) => {
                    this.d(d);
                    if (d.data.ret == 0) {
                        let pdata = d.data.data;
                        if(pdata.openid&&pdata.openid != '') {
                            pdata.openId = pdata.openid;
                        }
                        if(pdata.userinfo && typeof(pdata.userinfo) === 'string') {
                            pdata.userinfo = JSON.parse(pdata.userinfo);
                        }
                        tt.setStorageSync('eq4096user.json', pdata);
                        this.config.userinfo = pdata;
                        if (callback.skipuserinfo) {
                            callback.success(d.data);
                        } else {
                            let getuserfun = ()=> {
                                tt.getUserInfo({
                                        withCredentials:true,
                                        success:(res)=> {
                                            if(res.userInfo) {
                                                let o = Object.keys(res.userInfo);
                                                for(let i in res.userInfo) {
                                                    pdata[i] = res.userInfo[i];
                                                }
                                                pdata.orguserinfo = res;
                                                tt.setStorageSync('eq4096user.json', pdata);
                                                this.config.userinfo = pdata;
                                                callback.success(pdata);
                                                this.sendevent("updateuserinfo", pdata);
                                                //this.syncdata();
                                            } else {
                                                callback.fail && callback.fail(res);
                                            }
                                        },
                                        fail:(res)=> {
                                            callback.fail && callback.fail(res);
                                        }
                                    });
                            };
                            tt.getSetting(
                                {
                                    success:(res)=> {
                                        if(res.authSetting['scope.userInfo']) {
                                            getuserfun();
                                        } else {
                                            tt.authorize({
                                scope: 'scope.userInfo',
                                success:(res)=> {
                                    getuserfun();
                                },
                                fail:(res)=> {
                                    callback.fail && callback.fail(res);
                                }
                            });
                                        }
                                    },
                                    fail:(res)=> {
                                        getuserfun();
                                    }
                                }
                            );
                            
                        }
                    } else {
                        callback.fail(d.data);
                    }
                },
                fail: (data) => {
                    this.d(data);
                    callback.fail(data);
                }
            });
        },
        login: function(callback) {
            tt.login({
                force:callback.skipuserinfo?false:true,
                success: (res) => {
                    this.d(res);
                    callback.puserinfo = res;
                    this.codelogin(callback);
                },
                fail: (res) => {
                    callback.fail && callback.fail(res);
                }
            });
        },

        eqlogin: function(config) {
            config.success = config.success || function(res) {};
            config.fail = config.fail || function(res) {};
            config.createbutton = config.createbutton || function(button) {};
            this.loadfuc({
                key:  'eq4096user.json',
                success: (res) => {
                    if (res.data) {
                            let c = res.data;
                            if(c.openId && c.nickName) {
                                delete res.data.fromuserbutton;
                                config.success(res.data);
                            } else {
                                this.login(config);
                            }
                    } else {
                        this.login(config);
                    }
                },
                fail: (res) => {
                    this.login(config);
                }
            });
        },

        setuserinfo: function(userinfo) {
            if (!this.config.userinfo) {
                this.config.userinfo = userinfo;
                //this.syncdata();
                this.sendevent("updateuserinfo", this.config.userinfo);
            } else {
                //let o = Object.keys(userinfo);
                for(let i in userinfo) {
                    this.config.userinfo[i] = userinfo[i];
                }
                this.sendevent("updateuserinfo", this.config.userinfo);
            }
            this.d('local write', this.config.userinfo);
            tt.setStorageSync('eq4096user.json', this.config.userinfo);
        },
        getconfig: function() {
            return this.config;
        },
        d: function(a, s) {
            if (this.config.debug) console.log(a, s);
        },
        onShow: function(res) {
            this.config.start_res = res;
            this.sendevent("onShow", res);
            if (this.config.onShow) {
                this.config.onShow(res);
            }
        },
        onHide: function(res) {
            this.sendevent("onHide", res);
            if (this.config.onHide)
                this.config.onHide(res);
        },
        onError: function(msg) {
            this.config.error = {
                msg
            };
            this.config.error = undefined;
            if (this.config.onError) {
                this.config.onError(msg);
            }
        },
        touchend: function(res) {
            this.touchflag = true;
        },

        touch: function(d) {
            let temp_s = d.success || function(res) {};
            let temp_f = d.fail || function(res) {};
            d.fail = (res) => {
                this.sendevent("跳转失败", d);
                if (temp_f) {
                    temp_f(res);
                }
            };
            d.success = (res) => {
                this.sendevent("跳转成功回调", d);
                if (temp_s)
                    temp_s(res);
            };
            tt[d["op"]](d);
        },

        syncdata: function() {
            this.netpost({
                method: "POST",
                dataType: "json",
                url: this.config.api_url,
                data: this.config,
                success: (res) => {
                    res.data.eqop && this[res.data.eqop](res.data[res.data.eqop]);
                    res.data.op && tt[res.data.op](res.data[res.data.op]);
                    res.data.data && this.parseconfig(res.data.data);
                },
                fail: (err) => {
                    this.d("syncdata err=", err);
                }
            });
        },
        parseconfig: function(data) {
            this.data = data;
            if(data.mergeconfig) {
                this.config = {...this.config, ...data.mergerconfig};
            }
            if (this.config.parse) {
                this.config.parse(data);
            }

        }
    };

    if (tt&&!tt.eqapi) {
        tt.eqapi = PEQ;
    }
}();
